/*
 * Copyright (c)2004 Cat's Eye Technologies.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 
 *   Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 * 
 *   Neither the name of Cat's Eye Technologies nor the names of its
 *   contributors may be used to endorse or promote products derived
 *   from this software without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

/*
 * chain.h
 * $Id: chain.h,v 1.1 2004/07/09 23:25:41 cpressey Exp $
 */

#ifndef __CHAIN_H
#define __CHAIN_H

struct chain {
	struct chain_link *head;
	struct chain_link *tail;
};

struct chain_link {
	struct chain_link *next;
	struct chain_link *prev;
	char *string;
};

/*
 * PROTOTYPES
 */

struct chain		*chain_new(void);
void			 chain_free(struct chain *);
struct chain_link	*chain_first(struct chain *);
struct chain_link	*chain_last(struct chain *);
struct chain_link	*chain_link_next(struct chain_link *);
struct chain_link	*chain_link_prev(struct chain_link *);
char			*chain_link_get_string(struct chain_link *);
struct chain_link	*chain_add(struct chain *, char *, ...);
struct chain_link	*chain_find(struct chain *, char *, ...);
int			 chain_length(struct chain *ch);

#endif /* !__CHAIN_H */
