/*
 * Copyright (c)2004 Cat's Eye Technologies.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 
 *   Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 * 
 *   Neither the name of Cat's Eye Technologies nor the names of its
 *   contributors may be used to endorse or promote products derived
 *   from this software without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

/*
 * strpkg.h
 * $Id: strpkg.h,v 1.2 2004/07/10 02:35:22 cpressey Exp $
 */

#ifndef __STRPKG_H
#define __STRPKG_H

struct dfui_strpkg {
	struct extbuf *ebuf;	/* only used when is_static is false */
	char *sbuf;		/* only used when is_static is true */
	size_t size;		/* only used when is_static is true */
	int pos;
	int is_static;		/* if true, read-only & do not free sbuf */
};

/*
 * PROTOTYPES
 */

struct dfui_strpkg	*dfui_strpkg_new_dynamic(size_t);
struct dfui_strpkg	*dfui_strpkg_new_static(char *, size_t);
void			 dfui_strpkg_free(struct dfui_strpkg *);

char			*dfui_strpkg_buf(struct dfui_strpkg *);

int			 dfui_strpkg_write(struct dfui_strpkg *, char *);

int			 dfui_strpkg_at_end(struct dfui_strpkg *);
char			 dfui_strpkg_char(struct dfui_strpkg *);
char			 dfui_strpkg_char_advance(struct dfui_strpkg *);
int			 dfui_strpkg_compare(struct dfui_strpkg *, char *);
int			 dfui_strpkg_expect(struct dfui_strpkg *, char *);

#endif /* !__STRPKG_H */
